; MSX DOS2 utility for loading HAM images
;
;
; 

DATA   EQU #C000   ; Put your pallette data in this address
DATA2  EQU #C800

        org $100

        ; set screen 7

        di
        ld hl,reglist
        ld c,$99
a10
        ld a,(hl)
        cp $FF
        jp z,a16
        inc hl
        outi
        nop
        out (c),a
        jr a10
a16
        ei

        xor a
        call setvdpbank

        ; open file

        ld de,filename

        ld c,$43
        xor a
        call 5          ; Bdos
        jp nz,abort

        ld a,b
        ld (fhandle),a

        ; read header and palettes
        ld de,$BFE0
        ld hl,$052C
        call fread
        ld de,$C800
        ld hl,$050C
        call fread

        ; read screens
        ld de,$4000
        ld hl,$8000
        call fread
        call copytovram
        ld de,$4000
        ld hl,$5400
        call fread
        call copytovram

        ld a,4
        call setvdpbank
        ld de,$4000
        ld hl,$8000
        call fread
        call copytovram
        ld de,$4000
        ld hl,$5400
        call fread
        call copytovram

        ; close file
        ld a,(fhandle)
        ld b,a
        ld c,$45        ; close
        call 5
        jp nz,abort


        ld a,($2D)
        cp 3
        ld a,$80
        call z,$180 ; Change to Z80 if MSX tR


        di
        in a,($AA)
        and $F0
 	or 8
        out ($AA),a
        

	LD A,#90	 ; PALETTE register
	OUT (#99),A
	LD A,#91
	OUT (#99),A
AGAIN
	LD A,2
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

        LD HL,DATA      ; even field...
        in a,($99)
        and 2
        jr nz,field0
        LD HL,DATA2     ; or odd field?
field0

      	XOR A
      	OUT (#9B),A
      	LD BC,#209A
      	OTIR	; First palette

	LD A,1
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

WAITLINE0
	IN A,(#99)
	RRA
	JR NC,WAITLINE0

	LD A,2
	OUT (#99),A
	LD A,#8F
	OUT (#99),A

        LD E,209     ; Number of lines

        INC C
        OUTI
	DEC C
	OUTI
	OUTI

	INC C
	OUTI
	DEC C
	OUTI
	OUTI

WAIT
	IN A,(#99)
	AND 32
        JP Z,WAIT
;----------------------

        INC C
        OUTI
	DEC C
	OUTI
	OUTI

	INC C
	OUTI
	DEC C
	OUTI
	OUTI

	DEC E
	JP NZ,WAIT

;----------------------

     	IN A,(#A9)
	AND 1
	JP NZ,AGAIN ; SPACE pressed?

EXIT
	XOR A
	OUT (#99),A
	LD A,#8F
	OUT (#99),A
 	EI
	RET


setvdpbank
        di
;        ld a,0          ; bits 14-16
        out ($99),a
        ld a,$8E        ; bank register
        out ($99),a

        ld a,0          ; bits 0-7
        nop
        out ($99),a     

        ld a,$40        ; bits 8-13 + $40 for write access
        nop
        out ($99),a
        ei
        ret

fread
        ld a,(fhandle)
        ld b,a
        ld c,$48        ; read
        call 5
        cp $C7
        jp z,a15        ; eof?
        and a
        jp nz,abort
a15
        ret

copytovram
        ld de,$4000
        ex de,hl        ; hl had number of bytes read
a11
        ld a,(hl)
        out ($98),a
        inc hl
        dec de
        ld a,d
        or e
        jr nz,a11
        ret

abort
        ld b,a
        ld c,$62
        jp 5

reglist
        db $80,$0A
        db $81,$60
        db $82,$3F
        db $83,$80
        db $84,$00
        db $85,$F7
        db $86,$3E
        db $87,$00
        db $88,$0A
        db $89,$8C
        db $8A,$00
        db $8B,$03
        db $FF

filename
        db "BLAH.HAM",0

fhandle
        db 0
